; Marble/theme.jl

;; Copyright (C) 1999 Jess Bravo lvarez <jba@pobox.com>

;; This theme is based on the Marble enlightenment theme created by
;; Matthew Kirsch <kirsch@kirsch.cx>.

;; Now follows lexical scoped librep

(let*

  (

;; the font

    (font "-*-lucida-bold-r-normal-*-*-100-*-*-p-*-iso8859-1")

;; images

    (title-images (list (make-image "title-bar-inactive.png")
                        (make-image "title-bar-active.png")))

    (s-title-images (list 
        (set-image-border (make-image "s-title-bar-inactive.png") 5 5 0 0)
        (set-image-border (make-image "s-title-bar-active.png") 5 5 0 0)))

    (iconify-images (list (make-image "iconify-normal.png")
                                    nil nil
                                   (make-image "iconify-clicked.png")))

    (maximize-images (list (make-image "maximize-normal.png")
                                     nil nil
                                    (make-image "maximize-clicked.png")))

    (close-images (list (make-image "close-normal.png")
                                  nil nil
                                 (make-image "close-clicked.png")))

    (menu-images (list (make-image "menu-inactive.png")
                                (make-image "menu-active-normal.png") nil
                                (make-image "menu-active-clicked.png")))

    (horizontal-border-images (make-image "hor-border.png"))
    (vertical-border-images (make-image "ver-border.png"))

    (corner-images (make-image "corner.png"))

;; frame layout

    (frame
     `(

    ;; title

        ((background . ,title-images)
         (foreground . ("black" "white"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -15)
         (left-edge . 21)
         (right-edge . 42)
         (class . title)
        )

    ;; menu button

        ((background . ,menu-images)
         (top-edge . -15)
         (left-edge . 0)
         (class . menu-button)
        )

    ;; iconify button

        ((background . ,iconify-images)
         (top-edge . -15)
         (right-edge . 29)
         (class . iconify-button)
        )

    ;; maximize button

        ((background . ,maximize-images)
         (top-edge . -15)
         (right-edge . 15)
         (class . maximize-button)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -15)
         (right-edge . 0)
         (class . close-button)
        )

    ;; left border

        ((background . ,vertical-border-images)
         (top-edge . -15)
         (bottom-edge . 0)
         (left-edge . -4)
         (class . left-border)
        )

    ;; right border

        ((background . ,vertical-border-images)
         (top-edge . -15)
         (bottom-edge . 0)
         (right-edge . -4)
         (class . right-border)
        )

    ;; top border

        ((background . ,horizontal-border-images)
         (top-edge . -19)
         (right-edge . 0)
         (left-edge . 0)
         (class . top-border)
        )

    ;; bottom border

        ((background . ,horizontal-border-images)
         (bottom-edge . -4)
         (right-edge . 0)
         (left-edge . 0)
         (class . bottom-border)
        )

    ;; top-left corner

        ((background . ,corner-images)
         (top-edge . -19)
         (left-edge . -4)
         (class . top-left-corner)
        )

    ;; top-right corner

        ((background . ,corner-images)
         (top-edge . -19)
         (right-edge . -4)
         (class . top-right-corner)
        )

    ;; bottom-left corner

        ((background . ,corner-images)
         (bottom-edge . -4)
         (left-edge . -4)
         (class . bottom-left-corner)
        )

    ;; bottom-right corner

        ((background . ,corner-images)
         (bottom-edge . -4)
         (right-edge . -4)
         (class . bottom-right-corner)
        )
      )
    )

    (shaped-frame
     `(

    ;; title out

        ((background . ,s-title-images)
         (top-edge . -19)
         (left-edge . -4)
         (right-edge . -4)
         (class . title)
        )

    ;; title in

        ((background . ,title-images)
         (foreground . ("black" "white"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -15)
         (left-edge . 21)
         (right-edge . 42)
         (class . title)
        )

    ;; menu button

        ((background . ,menu-images)
         (top-edge . -15)
         (left-edge . 0)
         (class . menu-button)
        )

    ;; iconify button

        ((background . ,iconify-images)
         (top-edge . -15)
         (right-edge . 29)
         (class . iconify-button)
        )

    ;; maximize button

        ((background . ,maximize-images)
         (top-edge . -15)
         (right-edge . 15)
         (class . maximize-button)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -15)
         (right-edge . 0)
         (class . close-button)
        )
      )
    )

    (transient-frame
     `(

    ;; title out

        ((background . ,s-title-images)
         (top-edge . -23)
         (left-edge . 0)
         (right-edge . 0)
         (class . title)
        )

    ;; title in

        ((background . ,title-images)
         (foreground . ("black" "white"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -19)
         (left-edge . 25)
         (right-edge . 19)
         (class . title)
        )

    ;; menu button

        ((background . ,menu-images)
         (top-edge . -19)
         (left-edge . 4)
         (class . menu-button)
        )

    ;; close button

        ((background . ,close-images)
         (top-edge . -19)
         (right-edge . 4)
         (class . close-button)
        )
      )
    )

  )

;; frame definition

  (add-frame-style 'Marble 
    (lambda (w type)
      (case type
            ((default) frame)
            ((transient) transient-frame)
            ((shaped) shaped-frame)
            ((shaped-transient) transient-frame)
      )
    )
  )

)
